#ifndef CHROM_H
#define CHROM_H

//extern double log2( double) throw();
#include <math.h>
#include "assert.h"
#include "genome.h"
#include "params.h"
class Chrom
{
public:
    enum ChromType {
        BIT,
        INT,
        FLOAT
    };
    Chrom();
    void setParams( Params* params ){ this->params = params; }
    void setType( ChromType type );
    void setMin( int i );
    void setMax( int i );
    void setMin( long d ){ setMin( (int) d ); }
    void setMax( long d ){ setMin( (int) d ); }
    void setMin( float f );
    void setMax( float f );
    void setMin( double d ){ setMin( (float) d ); }
    void setMax( double d ){ setMin( (float) d ); }
    void updateLength();
    int getLength(){ return length; }
    bool getB( Genome* g );
    int getI( Genome* g );
    float getF( Genome* g );
    void setOffset( int i ){ offset = i; }
    char* toString();

protected:
    Params* params;
    ChromType type;
    int length;
    int offset;
    union {
        int intmin;
        float floatmin;
    };
    union {
        int intmax;
        float floatmax;
    };
    char string[1024];
};
    
#endif
