#!/usr/local/bin/tclsh

proc avg_file { inputfile outputfile } {
    set f [open $inputfile "r"]
    set numruns 0 
    set numgens 0
    for { set i 0 } { $i < 1000 } { incr i 1 } {
        set sum($i) 0
    }
    while { true } {
        gets $f s
        if { $s == "" } { break }
        set gen [ lindex $s 0 ]
        set val [ lindex $s 1 ]
        if { $gen == 0 } { incr numruns 1 }
        if { $gen > $numgens } { set numgens $gen }
        set sum($gen) [expr $sum($gen) + $val]
    }
    close $f
    puts "numruns : $numruns"
    for { set i 0 } { $i < $numgens } { incr i 1 } {
        set avg($i) [expr $sum($i) / $numruns]
    }
    
    set f [ open $outputfile "w"]
    for { set i 0 } { $i < $numgens } { incr i 1 } {
        puts $f "$i $avg($i)"
    }
    close $f
}

avg_file avglogs avgavglogs
avg_file minlogs avgminlogs
avg_file maxlogs avgmaxlogs
