#ifndef POPULATION_H
#define POPULATION_H
#include "genome.h"
#include "repres.h"
#include "stats.h"
class Population
{
    Params* params;
    nArray<Genome> genomes[2];
    int generation;
    char string[100000];
    Stats fitnessStats;
    Stats mappedFitnessStats;
    StatStats genFitnessStats;
    int z;
public:
    Population();
    void setParams( Params* params );
    void initialize();
    char* toString();
    void eval();
    void runGeneration();
    void mapFitnesses();
    void mapFitness( Genome& g );
    void selection();
    void sortPopulation();
    void crossover();
    void mutation();
    void logData();
    void logGenStats();
    Genome& operator[]( int index ){ return genomes[z][index]; }
};
    
#endif
