#include "repres.h"
Repres::Repres(){
    params = 0;
    genome = 0;
    isParsing = false;
}
void Repres::setParams( Params* params ){
    this->params = params;
}
void Repres::initialize(){
    params->genomeLength = 0;
}
void Repres::add( Chrom& c, nString name ){
    c.setOffset( params->genomeLength );
    printf("chromsome : [%20s]= %s\n", name.Get(), c.toString());
    chroms.Append( c );
    chromNames.Append( name );
    updateLength();
}
void Repres::updateLength(){
    int totalLength = 0;
    for( int i = 0; i < chroms.Size(); i ++ ){
        totalLength += chroms[i].getLength();
    }
    params->genomeLength = totalLength;
}
RepresHandle Repres::getHandle( nString name ){
    for( int i = 0; i < chromNames.Size(); i ++ )
        if( chromNames[i] == name )
            return i;
    return -1;
}
bool Repres::parseB( RepresHandle handle ){
    return chroms[(int) handle].getB( genome );
}
int Repres::parseI( RepresHandle handle ){
    return chroms[(int) handle].getI( genome );
}
float Repres::parseF( RepresHandle handle ){
    return chroms[(int) handle].getF( genome );
}
void Repres::startParse( Genome* g ){
    assert( !isParsing );
    isParsing = true;
    this->genome = g;
}
void Repres::stopParse(){
    isParsing = false;
}
