#ifndef REPRES_H
#define REPRES_H

#include "assert.h"
#include "chrom.h"
#include "nstring.h"
#include "narray.h"
typedef int RepresHandle;
class Repres
{
    Params* params;
    nArray<Chrom> chroms;
    nArray<nString> chromNames;
    Genome* genome;
    bool isParsing;
    
public:
    Repres();
    void setParams( Params* params );
    void initialize();
    void add( Chrom& c, nString name );
    void updateLength();
    RepresHandle getHandle( nString name );
    bool parseB( RepresHandle handle );
    int parseI( RepresHandle handle );
    float parseF( RepresHandle handle );
    void startParse( Genome* g );
    void stopParse();
};
    
#endif
