#ifndef STATS_H
#define STATS_H
#include <limits.h>

class Stats
{
    nArray<float> values;
public:
    float min, max, avg, mean, mode;
    float sum;
    int n;
    void add( float f){
        values.Append( f );
        n++;
        // MIN
        if( f < min )   min = f;
        //MAX
        if( f > max )   max = f;
        //AVG
        if( n == 0 )    avg = f;
        else            avg = avg * float(n-1) / float(n) + f / float(n);
        //MEAN - Need sorted list
        mean = 0;
        //MODE - Sorted list, or some kinda hash
        mode = 0;
        //SUM
        sum += f;
    }
    void clear(){
        n = 0;
        values.Clear();
        min = LONG_MAX;
        max = LONG_MIN;
        avg = 0;
        mean = 0;
        mode = 0;
        sum = 0;
    }
    nString toString(){
        char answer[1024];
        sprintf( answer, "min: %f max: %f avg: %f", min, max, avg );
        return nString( answer );
    }
};

class StatStats
{
    nArray< Stats > values;
public:
    void add( Stats s ) {
        values.Append( s );
    }
#define getFunc(var)\
    nString var(){\
        char answer[100024];\
        answer[0] = '\0';\
        for( int i = 0; i < values.Size(); i ++ )\
            sprintf( answer, "%s%i %.2f\n", answer, i, values[i].var );\
        return nString( answer );\
    }
        
    getFunc( avg )
    getFunc( min )
    getFunc( max )
    getFunc( mean )
    getFunc( mode )
    getFunc( sum )
};
#endif
