#ifndef GENOME_H
#define GENOME_H
#include <stdlib.h>
#include "params.h"
#include "nstring.h"
class Genome
{
    Params* params;
public:
    int* bits;
    float fitness;
    float mappedFitness;
    bool evaluated;

    Genome();
    ~Genome();
    void setParams( Params* params );
    void initialize();
    nString toString();
    void operator = ( const Genome& rhs );
    bool operator > ( const Genome& rhs ){ 
        assert(evaluated);
        assert(rhs.evaluated);
        return fitness > rhs.fitness; 
    }
    bool operator < ( const Genome& rhs ){ 
        assert(evaluated);
        assert(rhs.evaluated);
        return fitness < rhs.fitness; 
    }
    void eval();
    void randomize();
    void mutate();
    void crossoverWith( Genome &rhs );
};
#endif
